stages:
  - build-test
  - test
  - build-deploy
  - deploy

variables:
  BASE_IMAGE_PATH: "${CI_REGISTRY_IMAGE}/test:${CI_COMMIT_REF_SLUG}"
  DEPLOY_IMAGE_PATH: "${CI_REGISTRY_IMAGE}/deploy:${CI_COMMIT_REF_SLUG}"

workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE != "merge_request_event"'

# The first stage, base Docker image that is used both for running tests
# and as a base for the final container.

"build: test":
  stage: build-test
  image: docker:stable
  before_script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
  script:
    - echo "${MEMGEN_BRANCH}"
    - if [ -z "${MEMGEN_BRANCH}" ]; then
        docker build --build-arg MODE="deploy" -t "${BASE_IMAGE_PATH}" . ;
      else
        docker build --build-arg MEMGEN_BRANCH="${MEMGEN_BRANCH}" --build-arg MODE="deploy" -t "${BASE_IMAGE_PATH}" . ;
      fi
    - docker push "${BASE_IMAGE_PATH}"
  tags:
    - docker
    - skylake

test:
  stage: test
  image: "${BASE_IMAGE_PATH}"
  script:
    - npm ci
    - npm run test
  tags:
    - zen3

# The second stage, Docker container for production

"build: deploy":
  stage: build-deploy
  image: docker:stable
  before_script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
  script:
    - docker build --build-arg BASE_IMAGE="${BASE_IMAGE_PATH}" -f deploy.Dockerfile -t "${DEPLOY_IMAGE_PATH}" .
    - docker push "${DEPLOY_IMAGE_PATH}"
  tags:
    - docker
    - skylake

.deploy:
  variables:
    GIT_STRATEGY: none
  image: docker:stable
  stage: deploy
  before_script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
  script:
    - docker pull "${DEPLOY_IMAGE_PATH}" || true
    - docker stop --time 10 ${CONTAINER_NAME} || true
    - docker container rm ${CONTAINER_NAME} || true
    - docker run
      -p ${PORT}:3000 --restart always --name "${CONTAINER_NAME}"
      -d -it "${DEPLOY_IMAGE_PATH}"
  tags:
    - memgen-docker-deployment

# Deployment

"deploy: memgen-api":
  extends: .deploy
  variables:
    PORT: 3004
    CONTAINER_NAME: "memgen-api"
  rules:          
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $MEMGEN_BRANCH == $CI_DEFAULT_BRANCH
      when: always
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH || $MEMGEN_BRANCH != $CI_DEFAULT_BRANCH
      when: manual
      allow_failure: true

"deploy: memgen-dev-api":
  extends: .deploy
  variables:
    PORT: 3005
    CONTAINER_NAME: "memgen-dev-api"
